# Vite Plugin OX Externals

A vite plugin that will mark prefixed modules as external and will transform the path in production into a path relative to the root.

## Install

```sh
pnpm i "@open-xchange/vite-plugin-ox-externals"
```

## How to use

```js
// in the vite.config.js
import vitePluginOxExternals from '@open-xchange/vite-plugin-ox-externals'

return {
  plugins: [vitePluginOxExternals()]
}
```

## Options

You can provide the following options to the plugin:

| Name | Type | Default | Description |
| -- | -- | -- | -- |
| `prefix` | `string` | `'$'` | The prefix to use for external modules. Will always be followed by a `/` if you specify the path. |

## Example

```js
// import the core settings module
import { Settings } from '$/io.ox/core/settings'
```

## How to test

```sh
pnpm test
```
