import { describe, it, expect } from 'vitest'
import { createServer } from 'vite'

import vitePluginOxManifests from '../../dist/index'
import { getPort } from '../util'

const __dirname = import.meta.dirname

describe('deps', () => {
  it('should deliver empty deps in dev mode', async () => {
    const server = await createServer({
      root: __dirname,
      logLevel: 'silent',
      plugins: [vitePluginOxManifests({})]
    })
    const PORT = await getPort()
    await server.listen(PORT)

    const res = await fetch(`http://localhost:${PORT}/api/deps.json`)
    const deps = await res.json()
    expect(deps).toEqual({})
    await server.close()
  })
})
